diff --git a/test/ruby/test_proc.rb b/test/ruby/test_proc.rb
index 3f0d599a04..672738d0b4 100644
--- a/test/ruby/test_proc.rb
+++ b/test/ruby/test_proc.rb
@@ -1505,27 +1505,27 @@ def test_compose_keywords
     g = ->(kw) { kw.merge(:a=>2) }
 
     assert_equal(2, (f >> g).call(a: 3)[:a])
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (f << g).call(a: 3)[:a])
     end
     assert_equal(2, (f >> g).call(a: 3)[:a])
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (f << g).call({a: 3})[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(2, (f >> g).call({a: 3})[:a])
     end
     assert_equal(2, (g << f).call(a: 3)[:a])
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (g >> f).call(a: 3)[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(2, (g << f).call({a: 3})[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (g >> f).call({a: 3})[:a])
     end
-    assert_warn(/Passing the keyword argument as the last hash parameter is deprecated.*Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Passing the keyword argument as the last hash parameter is deprecated.*Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (f << g).call(**{})[:a])
     end
     assert_equal(2, (f >> g).call(**{})[:a])
@@ -1535,27 +1535,27 @@ def test_compose_keywords_method
     f = ->(**kw) { kw.merge(:a=>1) }.method(:call)
     g = ->(kw) { kw.merge(:a=>2) }.method(:call)
 
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (f << g).call(a: 3)[:a])
     end
     assert_equal(2, (f >> g).call(a: 3)[:a])
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (f << g).call({a: 3})[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(2, (f >> g).call({a: 3})[:a])
     end
     assert_equal(2, (g << f).call(a: 3)[:a])
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (g >> f).call(a: 3)[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(2, (g << f).call({a: 3})[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (g >> f).call({a: 3})[:a])
     end
-    assert_warn(/Passing the keyword argument as the last hash parameter is deprecated.*Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Passing the keyword argument as the last hash parameter is deprecated.*Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (f << g).call(**{})[:a])
     end
     assert_equal(2, (f >> g).call(**{})[:a])
@@ -1569,27 +1569,27 @@ def g.to_proc; method(:call).to_proc; end
     def g.<<(f) to_proc << f end
     def g.>>(f) to_proc >> f end
 
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (f << g).call(a: 3)[:a])
     end
     assert_equal(2, (f >> g).call(a: 3)[:a])
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (f << g).call({a: 3})[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(2, (f >> g).call({a: 3})[:a])
     end
     assert_equal(2, (g << f).call(a: 3)[:a])
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (g >> f).call(a: 3)[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(2, (g << f).call({a: 3})[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method is defined here/m) do
       assert_equal(1, (g >> f).call({a: 3})[:a])
     end
-    assert_warn(/Passing the keyword argument as the last hash parameter is deprecated.*The called method `call'/m) do
+    assert_warning(/Passing the keyword argument as the last hash parameter is deprecated.*The called method `call'/m) do
       assert_equal(1, (f << g).call(**{})[:a])
     end
     assert_equal(2, (f >> g).call(**{})[:a])
@@ -1602,27 +1602,27 @@ def g.<<(f) to_proc << f end
     def g.>>(f) to_proc >> f end
 
     assert_equal(1, (f << g).call(a: 3)[:a])
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
       assert_equal(2, (f >> g).call(a: 3)[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
       assert_equal(1, (f << g).call({a: 3})[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
       assert_equal(2, (f >> g).call({a: 3})[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
       assert_equal(2, (g << f).call(a: 3)[:a])
     end
     assert_equal(1, (g >> f).call(a: 3)[:a])
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
       assert_equal(2, (g << f).call({a: 3})[:a])
     end
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
       assert_equal(1, (g >> f).call({a: 3})[:a])
     end
     assert_equal(1, (f << g).call(**{})[:a])
-    assert_warn(/Passing the keyword argument as the last hash parameter is deprecated.*Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
+    assert_warning(/Passing the keyword argument as the last hash parameter is deprecated.*Using the last argument as keyword parameters is deprecated.*The called method `call'/m) do
       assert_equal(2, (f >> g).call(**{})[:a])
     end
   end
diff --git a/test/ruby/test_struct.rb b/test/ruby/test_struct.rb
index f13afbbdd4..81437a9339 100644
--- a/test/ruby/test_struct.rb
+++ b/test/ruby/test_struct.rb
@@ -115,9 +115,9 @@ def test_struct_new_with_keyword_init
     assert_equal "#{@Struct}::KeywordInitTrue(keyword_init: true)", @Struct::KeywordInitTrue.inspect
     # eval is needed to prevent the warning duplication filter
     k = eval("Class.new(@Struct::KeywordInitFalse) {def initialize(**) end}")
-    assert_warn(/Using the last argument as keyword parameters is deprecated/) {k.new(a: 1, b: 2)}
+    assert_warning(/Using the last argument as keyword parameters is deprecated/) {k.new(a: 1, b: 2)}
     k = Class.new(@Struct::KeywordInitTrue) {def initialize(**) end}
-    assert_warn('') {k.new(a: 1, b: 2)}
+    assert_warning('') {k.new(a: 1, b: 2)}
 
     @Struct.instance_eval do
       remove_const(:KeywordInitTrue)
diff --git a/test/ruby/test_syntax.rb b/test/ruby/test_syntax.rb
index 21b0bc7ce7..65475ff2ff 100644
--- a/test/ruby/test_syntax.rb
+++ b/test/ruby/test_syntax.rb
@@ -182,7 +182,7 @@ def test_keyword_duplicated_splat
     h = {k3: 31}
     assert_raise(ArgumentError) {o.kw(**h)}
     h = {"k1"=>11, k2: 12}
-    assert_warn(/Splitting the last argument into positional and keyword parameters is deprecated.*The called method `kw'/m) do
+    assert_warning(/Splitting the last argument into positional and keyword parameters is deprecated.*The called method `kw'/m) do
       assert_raise(ArgumentError) {o.kw(**h)}
     end
   end
diff --git a/test/test_delegate.rb b/test/test_delegate.rb
index 426a647808..09769001eb 100644
--- a/test/test_delegate.rb
+++ b/test/test_delegate.rb
@@ -190,7 +190,7 @@ def foo.foo(*args, **kw)
     assert_equal([], d.bar)
     assert_equal([[], {:a=>1}], d.foo(:a=>1))
     assert_equal([{:a=>1}], d.bar(:a=>1))
-    assert_warn(/Using the last argument as keyword parameters is deprecated.*The called method `foo'/m) do
+    assert_warning(/Using the last argument as keyword parameters is deprecated.*The called method `foo'/m) do
       assert_equal([[], {:a=>1}], d.foo({:a=>1}))
     end
     assert_equal([{:a=>1}], d.bar({:a=>1}))
diff --git a/vm_args.c b/vm_args.c
index cf0328d4b7..abac745f16 100644
--- a/vm_args.c
+++ b/vm_args.c
@@ -597,7 +597,7 @@ static st_table *caller_to_callees = 0;
 static VALUE
 rb_warn_check(const rb_execution_context_t * const ec, const rb_iseq_t *const iseq)
 {
-    if (!rb_warning_category_enabled_p(RB_WARN_CATEGORY_DEPRECATED)) return 1;
+    if (!rb_warning_category_enabled_p(RB_WARN_CATEGORY_DEPRECATED) || !ruby_verbose) return 1;
 
     if (!iseq) return 0;
 
-- 
2.27.0

